
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <RTClib.h>
#include "Adafruit_LEDBackpack.h"
#include <LiquidCrystal.h>
#include <Keypad.h>

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
#define passwordLength 8

char Data[passwordLength];
char dataStore[passwordLength][10];
char codes[passwordLength][10] = {"1","2","3","4","5","6","7","9"};
char storeCode;
int flag = 0;

byte dataCount = 0;
char customKey;

const int buzzer = 30;

const byte ROWS = 4;
const byte COLS = 3;

char hexaKeys[ROWS][COLS] = {
  {'1', '2', '3'},
  {'4', '5', '6'},
  {'7', '8', '9'},
  {'*', '0', '#'}
};

byte rowPins[ROWS] = {25, 26, 27, 28};
byte colPins[COLS] = {22, 23, 24};

//initialize an instance of class NewKeypad
Keypad customKeypad = Keypad(makeKeymap(hexaKeys), rowPins, colPins, ROWS, COLS);


// Set to false to display time in 12 hour format, or true to use 24 hour:
#define TIME_24_HOUR      true

// I2C address of the display.  Stick with the default address of 0x70
// unless you've changed the address jumpers on the back of the display.
#define DISPLAY_ADDRESS   0x70

#define HOURS_LIMIT 23

#define MINUTES_LIMIT 59


// Create display and DS1307 objects.  These are global variables that
// can be accessed from both the setup and loop function below.
Adafruit_7segment clockDisplay = Adafruit_7segment();
RTC_DS1307 rtc = RTC_DS1307();

// Keep track of the hours, minutes, seconds displayed by the clock.
// Start off at 0:00:00 as a signal that the time should be read from
// the DS1307 to initialize it.
int hours = 0;
int minutes = 0;
int seconds = 0;
int power_loss = 0;

// this constant won't change:
const int ledPin = 13;       // the pin that the LED is attached to
const int alarm_configure = 10;
const int inc = 11;
const int alarm_set = 12;
//const int alarm_ack = 25;

// Variables will change:
int buttonPushCounter = 0;   // counter for the number of button presses
int buttonState = 0;         // current state of the button
int lastButtonState = 0;     // previous state of the button
int set_alarm_hours = 0;
int set_alarm_minutes = 0;
int button_1 = 0;
int button_2 = 0;
int button_3 = 0;

int alarm_set_flag = 0;
int alarm_configure_H_flag = 0;
int alarm_configure_M_flag = 0;
int alarm_on_flag = 0;
// Remember if the colon was drawn on the display so it can be blinked
// on and off every second.
bool blinkColon = false;


void setup() {
  // Setup function runs once at startup to initialize the display
  // and DS1307 clock.


  // initialize the LED as an output:
  pinMode(ledPin, OUTPUT);
  pinMode(alarm_set,INPUT);
  pinMode(inc,INPUT);
  pinMode(alarm_configure, INPUT);
  pinMode(buzzer, OUTPUT);
  

  // Setup Serial port to print debug output.
  Serial.begin(115200);
  Serial.println("Clock starting!");

  // Setup the display.
  clockDisplay.begin(DISPLAY_ADDRESS);

  // Setup the DS1307 real-time clock.
  rtc.begin();

  // Set the DS1307 clock if it hasn't been set before.
  bool setClockTime = !rtc.isrunning();
  // Alternatively you can force the clock to be set again by
  // uncommenting this line:
  setClockTime = false;
  if (setClockTime) {
    Serial.println("Setting DS1307 time!");
    // This line sets the DS1307 time to the exact date and time the
    // sketch was compiled:
    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
    // Alternatively you can set the RTC with an explicit date & time, 
    // for example to set January 21, 2014 at 3am you would uncomment:
    //rtc.adjust(DateTime(2014, 1, 21, 3, 0, 0));
  }

    randomSeed(analogRead(6));
    lcd.begin(16,2); 
    lcd.setCursor(0,0);

    
    lcd.print("Team 8");
    lcd.setCursor(0,1);
    lcd.print("Alarm Clock");

//    lcd.setCursor(0,0);
//    lcd.print("Passcode:");
//    lcd.setCursor(9,0);
//    shuffle(codes, sizeof(codes)/sizeof(codes[0])); // shuffle the list of strings
//    for (int i = 0; i < sizeof(codes)/sizeof(codes[0]); i++) {
//      lcd.print(codes[i]); // print the shuffled strings
//      Serial.print(codes[i]);


}

void loop() {
  // Loop function runs over and over again to implement the clock logic.
  //Serial.print("Power_loss Status: ");
  //Serial.println(power_loss);
  
  if(power_loss == 0)
  {
   // Get the time from DS1307
      Update_Time();

   // Disable power loss flag
      power_loss = 1;
    
  }
  // Check if it's the top of the hour and get a new time reading
  // from the DS1307.  This helps keep the clock accurate by fixing
  // any drift.
  if (minutes == 0) {
    
    // Get the time from the DS1307.
      Update_Time();
  }

  // Show the time on the display by turning it into a numeric
  // value, like 3:30 turns into 330, by multiplying the hour by
  // 100 and then adding the minutes.
  int displayValue = hours*100 + minutes;

  // Do 24 hour to 12 hour format conversion when required.
  if (!TIME_24_HOUR) {
    // Handle when hours are past 12 by subtracting 12 hours (1200 value).
    if (hours > 12) {
      displayValue -= 1200;
    }
    // Handle hour 0 (midnight) being shown as 12.
    else if (hours == 0) {
      displayValue += 1200;
    }
  }

  // Now print the time value to the display.
  clockDisplay.print(displayValue, DEC);

  //Add Leading zero for Hour when morning
  if(hours < 10){
    
     clockDisplay.writeDigitNum(0, 0);    
  }
  
  // Add zero padding when in 24 hour mode and it's midnight.
  // In this case the print function above won't have leading 0's
  // which can look confusing.  Go in and explicitly add these zeros.
  if (TIME_24_HOUR && hours == 0) {
    // Pad hour 0.
    clockDisplay.writeDigitNum(1, 0);
    // Also pad when the 10's minute is 0 and should be padded.
    if (minutes < 10) {
      clockDisplay.writeDigitNum(2, 0);
    }
  }

  // Blink the colon by flipping its value every loop iteration
  // (which happens every second).
  blinkColon = !blinkColon;
  clockDisplay.drawColon(blinkColon);

  // Now push out to the display the new values that were set above.
  clockDisplay.writeDisplay();

  if((minutes == set_alarm_minutes) && (hours == set_alarm_hours) && (seconds == 0))
  {
    Serial.print("!Alarm!");
    Serial.println();
    Serial.print("Do something");
    Serial.println();

    alarm_on_flag = 1;

    lcd.setCursor(0,0);
    lcd.print("Passcode:");
    lcd.setCursor(9,0);
    shuffle(codes, sizeof(codes)/sizeof(codes[0])); // shuffle the list of strings
    for (int i = 0; i < sizeof(codes)/sizeof(codes[0]); i++) {
      lcd.print(codes[i]); // print the shuffled strings
      Serial.print(codes[i]);
    }

    while(alarm_on_flag == 1)
    {

    customKey = customKeypad.getKey();
    tone(buzzer, 5000);
    if (customKey) {
      // Enter keypress into array and increment counter
      Data[dataCount] = customKey;
      lcd.setCursor(dataCount, 1);
      lcd.print(Data[dataCount]);
      dataCount++;
    }
   
    if (dataCount == passwordLength - 1) {
      lcd.clear();
    }

    
   
    // See if we have reached the password length
    if (dataCount == passwordLength - 1) {
      lcd.clear();
     
      if (codes[0][0] == Data[0]) {
          if (codes[1][0] == Data[1]) {
            if (codes[2][0] == Data[2]) {
              if (codes[3][0] == Data[3]) {
                if (codes[4][0] == Data[4]) {
                  if (codes[5][0] == Data[5]) {
                    if (codes[6][0] == Data[6]) {
                      lcd.print("Correct");
                      noTone(buzzer);
                      delay(1000);
                      alarm_on_flag = 0;
                      minutes = 0; 
                    }
                  }
                }
              }
            }
          }  
      }
 
     
      else{
       lcd.clear();

       lcd.setCursor(0,0);
        
       // Password is incorrect
       lcd.print("Incorrect");

       delay(1000);
        
       clearData();

       lcd.clear();
      
        lcd.setCursor(0,0);
        lcd.print("Passcode:");
        lcd.setCursor(9,0);
        shuffle(codes, sizeof(codes)/sizeof(codes[0])); // shuffle the list of strings
        for (int i = 0; i < sizeof(codes)/sizeof(codes[0]); i++) {
        lcd.print(codes[i]); // print the shuffled strings
        Serial.print(codes[i]);

      }

     
      }
      
     
     
      
      
    }

   }

   alarm_display();
   delay(100);
    
    
  }

  // Pause for a second for time to elapse.  This value is in milliseconds
  // so 1000 milliseconds = 1 second.
  delay(1000);

  // Now increase the seconds by one.
  seconds += 1;
  // If the seconds go above 59 then the minutes should increase and
  // the seconds should wrap back to 0.

  Serial.print(hours);
  Serial.print(' ');
  Serial.print(minutes);
  Serial.print(' ');
  Serial.print(seconds);
  Serial.println();
  
  if (seconds > 59) {
    seconds = 0;
    minutes += 1;
    // Again if the minutes go above 59 then the hour should increase and
    // the minutes should wrap back to 0.
    if (minutes > 59) {
      minutes = 0;
      hours += 1;
      // Note that when the minutes are 0 (i.e. it's the top of a new hour)
      // then the start of the loop will read the actual time from the DS1307
      // again.  Just to be safe though we'll also increment the hour and wrap
      // back to 0 if it goes above 23 (i.e. past midnight).
      if (hours > 23) {
        hours = 0;
      }
    }
  }

  button_1 = digitalRead(alarm_configure);

//   Serial.print("Alarm Configure Status: ");
//   Serial.println(button_1);

  
  if (button_1 == HIGH)
  {
     delay(50);
     lcd.clear();
     lcd.setCursor(0,0);
     lcd.print("Set Hours");
     Serial.println("Set Hours");
     
     delay(50);
     alarm_configure_H_flag = 1;

      while(alarm_configure_H_flag == 1)
      {
        button_detect();
  
        if (buttonPushCounter > HOURS_LIMIT)
        {
            buttonPushCounter = 0;
            lcd.clear();
            delay(50);
            lcd.setCursor(0,0);
            lcd.print("Hour: ");
            Serial.print("Hour: ");
            lcd.setCursor(5,0);
            lcd.print(buttonPushCounter);
            Serial.println(buttonPushCounter);
        }
  
        button_2 = digitalRead(alarm_set);
        //Serial.print("Alarm Set Status: ");
        //Serial.println(button_2);
        //delay(50);
      
        if(button_2 == HIGH)
        {
          
         alarm_configure_H_flag = 0;
         set_alarm_hours = buttonPushCounter;
         lcd.clear();
         delay(50);
         lcd.setCursor(0,0);
         lcd.print("Alarm Hour Set!");
         Serial.print("Alarm Hour Set! H: ");
         Serial.println(set_alarm_hours);
         //Serial.println(buttonPushCounter);
         buttonPushCounter = 0;
         alarm_configure_M_flag = 1;
         delay(500);
  
         while(button_2 == HIGH)
         {
            button_2 = digitalRead(alarm_set);
            
         }        
        }     
      }

     delay(50);
     Serial.println("Set Minutes");
     lcd.clear();
     delay(50);
     lcd.setCursor(0,0);
     lcd.print("Set Minutes");
     
      while(alarm_configure_M_flag == 1)
      {
          button_detect();
          
          if (buttonPushCounter > MINUTES_LIMIT)
          {
            buttonPushCounter = 0;
            Serial.print("Minutes: ");
            Serial.println(buttonPushCounter);
            
          }
    
          button_2 = digitalRead(alarm_set);
          //Serial.print("Alarm Set Status: ");
          //Serial.println(button_2);
          //delay(50);
        
          if(button_2 == HIGH)
          {
            
           alarm_configure_M_flag = 0;
           set_alarm_minutes = buttonPushCounter;
           lcd.clear();
           delay(50);
           lcd.setCursor(0,0);
           lcd.print("Alarm Minute Set!");
           Serial.print("Alarm Minute Set! M: ");
           Serial.println(set_alarm_minutes);
           //Serial.println(buttonPushCounter);
           buttonPushCounter = 0;
           alarm_set_flag = 1;
    
            while(button_2 == HIGH)
            {
              button_2 = digitalRead(alarm_set);
            }
            
          }     
       }

  }
 
   if(alarm_set_flag == 1)
   {

       alarm_display();
       
//     lcd.clear();
//     lcd.setCursor(0,0);
//     lcd.print("Alarm is ");
//     Serial.print("Alarm is ");
//     
//     if(set_alarm_hours < 10)
//     {
//      lcd.setCursor(9,0);
//      lcd.print("0");
//      Serial.print("0");
//      lcd.setCursor(10,0);
//      lcd.print(set_alarm_hours);
//      lcd.setCursor(11,0);
//      lcd.print(":");
//     }
//     else
//     {
//      lcd.setCursor(9,0);
//      lcd.print(set_alarm_hours);
//      Serial.print(set_alarm_hours);
//      lcd.setCursor(11,0);
//      lcd.print(":");
//     }
//
//     if(set_alarm_minutes < 10)
//     {
//      Serial.print("0");
//      lcd.setCursor(12,0);
//      lcd.print("0");
//      lcd.setCursor(13,0);
//      lcd.print(set_alarm_minutes);
//     }
//     else
//     {
//      lcd.setCursor(12,0);
//      lcd.print(set_alarm_minutes);
//     }
     
//     lcd.setCursor(9,0);
//     lcd.print(set_alarm_hours);
//     Serial.print(set_alarm_hours);
//     Serial.print(":");

//    

     minutes = 0;
     alarm_set_flag = 0;
        
   }

// Loop code is finished, it will jump back to the start of the loop
// function again!
}

void button_detect(void)
{
  // read the pushbutton input pin:
  buttonState = digitalRead(inc);

  // compare the buttonState to its previous state
  if (buttonState != lastButtonState) {
    // if the state has changed, increment the counter
    if (buttonState == HIGH) {
      // if the current state is HIGH then the button went from off to on:
      buttonPushCounter++;
      //Serial.println("on");
      if((alarm_configure_H_flag == 1) && (buttonPushCounter <= HOURS_LIMIT)){
      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print("Hour: ");
      lcd.setCursor(5,0);
      lcd.print(buttonPushCounter);
      Serial.print("Hour: ");
      Serial.println(buttonPushCounter);
     }
       else if((alarm_configure_M_flag == 1) && (buttonPushCounter <= MINUTES_LIMIT)){
      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print("Minutes: ");
      lcd.setCursor(9,0);
      lcd.print(buttonPushCounter);
      Serial.print("Minutes: ");
      Serial.println(buttonPushCounter);
     }  
    else {
      // if the current state is LOW then the button went from on to off:
      //Serial.println("off");
    }
    // Delay a little bit to avoid bouncing
    delay(35);
  }
  // save the current state as the last state, for next time through the loop
  lastButtonState = buttonState;


  // turns on the LED every four button pushes by checking the modulo of the
  // button push counter. the modulo function gives you the remainder of the
  // division of two numbers:
  if (buttonPushCounter % 4 == 0) {
    digitalWrite(ledPin, HIGH);
  } else {
    digitalWrite(ledPin, LOW);
  }
}
}

void Update_Time (void)
{
      DateTime now = rtc.now();
    // Print out the time for debug purposes:
    Serial.print("Read date & time from DS1307: ");
    Serial.print(now.year(), DEC);
    Serial.print('/');
    Serial.print(now.month(), DEC);
    Serial.print('/');
    Serial.print(now.day(), DEC);
    Serial.print(' ');
    Serial.print(now.hour(), DEC);
    Serial.print(':');
    Serial.print(now.minute(), DEC);
    Serial.print(':');
    Serial.print(now.second(), DEC);
    Serial.println();
    // Now set the hours and minutes.
    hours = now.hour();
    minutes = now.minute();
    seconds = now.second();
}

void clearData() {
  // Go through array and clear data
  while (dataCount != 0) {
    Data[dataCount--] = 0;
  }
  return;
}

void shuffle(char array[][10], int size) {
  for (int i = size - 1; i > 0; i--) {
    int j = random(i + 1);
    char temp[10];
    strcpy(temp, array[i]);
    strcpy(array[i], array[j]);
    strcpy(array[j], temp);

  }
}

void alarm_display(void)
{
     lcd.clear();
     lcd.setCursor(0,0);
     lcd.print("Alarm is ");
     Serial.print("Alarm is ");
     
     if(set_alarm_hours < 10)
     {
      lcd.setCursor(9,0);
      lcd.print("0");
      Serial.print("0");
      lcd.setCursor(10,0);
      lcd.print(set_alarm_hours);
      lcd.setCursor(11,0);
      lcd.print(":");
     }
     else
     {
      lcd.setCursor(9,0);
      lcd.print(set_alarm_hours);
      Serial.print(set_alarm_hours);
      lcd.setCursor(11,0);
      lcd.print(":");
     }

     if(set_alarm_minutes < 10)
     {
      Serial.print("0");
      lcd.setCursor(12,0);
      lcd.print("0");
      lcd.setCursor(13,0);
      lcd.print(set_alarm_minutes);
     }
     else
     {
      lcd.setCursor(12,0);
      lcd.print(set_alarm_minutes);
     }  
}
